<%@ Page Language="C#" AutoEventWireup="true" Inherits="Sitecore.ChangesTracker.UI.Comparer" %>

<%@ Import Namespace="Sitecore.Globalization" %>
<%@ Register TagPrefix="sc" Namespace="Sitecore.Web.UI.HtmlControls" Assembly="Sitecore.Kernel" %>
<%@ Register TagPrefix="sc" Namespace="Sitecore.Web.UI.WebControls.Ribbons" Assembly="Sitecore.Kernel" %>

<asp:placeholder id="DocumentType" runat="server" />
<html>
<head id="Head1" runat="server">
    <asp:placeholder id="BrowserTitle" runat="server" />
    <sc:Stylesheet ID="Stylesheet1" runat="server" Src="Content Manager.css" DeviceDependant="true" />
    <sc:Stylesheet Src="Ribbon.css" DeviceDependant="true" runat="server" />
    <sc:Stylesheet Src="ChangeTrackerRibbon.css" DeviceDependant="true" runat="server" />
    <asp:placeholder id="Stylesheets" runat="server" />
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/controls/SitecoreObjects.js"></script>
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/controls/SitecoreKeyboard.js"></script>
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/controls/SitecoreVSplitter.js"></script>
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/controls/SitecoreWindow.js"></script>
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/Applications/Content Manager/Content Editor.js"></script>
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/controls/TreeviewEx/TreeviewEx.js"></script>
    <script type="text/JavaScript" language="javascript" src="/sitecore/shell/controls/SitecoreModifiedHandling.js"></script>
    <script type="text/javascript">
        function OnResize() {
            var header = $("HeaderRow");
            var footer = $("FooterRow");

            var editor = $("EditorPanel");
            var ribbon = $("RibbonContainer");
            var height = window.innerHeight - header.getHeight() - footer.getHeight() + 'px';

            editor.setStyle({ height: height });
        }

        if (Prototype.Browser.Gecko) {
            Event.observe(window, "load", OnResize);
            Event.observe(window, "resize", OnResize);
        }
    </script>
    <style type="text/css">
        .scEditorWarningPanelTable
        
        {
            display:none;
        }
        #Editors, #MainPanel
        {
            background: #f0f1f2 !important;
        }
        
        #EditorPanel, .scEditorPanelCell
        {
            /*
      background-color: #f0f1f2;
      border: none;
  */
            padding-bottom: 1px;
        }
        
        .scEditorPanelCell
        {
            padding-bottom: 1px;
        }
        
        .ie #ValidatorPanel
        {
            margin-top: -1px;
        }
        
        .scEditorSections
        {
            /* border-bottom: none; */
            margin-right: -1px;
            background: blue;
        }
        
        .ff .scEditorSections
        {
            margin-top: -2px;
        }
        
        #HeaderRow
        {
            display: none;
        }
        
        #FooterRow
        {
        }
        
        #FooterRow td
        {
            border-top: solid 1px #DBDBDB;
        }
        
        #FooterRow input
        {
            margin-right: 4px;
        }
        
        .scEditorSectionPanelCell
        {
            padding-left: 8px;
        }
        
        .scEditorSectionCaptionExpanded
        {
            padding: 1px 2px 1px 2px;
        }
        
        .scButton
        {
            font: 8pt tahoma;
        }
    </style>
</head>
<body runat="server" id="Body" onmousedown="javascript:scWin.mouseDown(this, event)"
    onmousemove="javascript:scWin.mouseMove(this, event)" onmouseup="javascript:scWin.mouseUp(this, event)"
    style="background-color: #e9e9e9; overflow: hidden;">
    <form id="ComparerForm" runat="server">
    <sc:CodeBeside ID="CodeBeside1" runat="server" Type="Sitecore.ChangesTracker.UI.ComparerForm" />
    <asp:PlaceHolder ID="scLanguage" runat="server" />
    <input type="hidden" id="scEditorTabs" name="scEditorTabs" />
    <input type="hidden" id="scActiveEditorTab" name="scActiveEditorTab" />
    <input type="hidden" id="scPostAction" name="scPostAction" />
    <input type="hidden" id="scShowEditor" name="scShowEditor" />
    <input type="hidden" id="scSections" name="scSections" />
    <div id="outline" class="scOutline" style="display: none">
    </div>
    <span id="scPostActionText" style="display: none">
        <sc:Literal ID="Literal1" Text="The main window could not be updated due to the current browser security settings. You must click the Refresh button yourself to view the changes."
            runat="server" />
    </span>
    <iframe id="feRTEContainer" src="about:blank" style="position: absolute; width: 100%;
        height: 100%; top: 0px; left: 0px; right: 0px; bottom: 0px; z-index: 999; border: none;
        display: none" frameborder="0" allowtransparency="allowtransparency"></iframe>
    <div>
        <sc:Border ID="RibbonContainer" runat="server">
            <sc:Ribbon ID="ribbon" runat="server" />
        </sc:Border>
        <div style="position: absolute; overflow-x: hidden; overflow-y: scroll; height: 90%;
            width: 100%;">
            <sc:Border ID="ContentEditor" runat="server" Class="scEditor" />
        </div>
    </div>
    </form>
</body>
</html>
